package com.domemusictechnologies.cvdelay;


import voltage.controllers.*;
import voltage.core.*;
import voltage.core.Jack.JackType;
import voltage.sources.*;
import voltage.utility.*;
import voltage.processors.*;
import voltage.effects.*;
import java.awt.*;

//[user-imports]   Add your own imports here

import static java.lang.Math.round; // Round double to nearest integer value
import static java.lang.Math.pow;   // Raise to power method, used for V/oct calc

//[/user-imports]


public class CVDelay extends VoltageModule
//[user-inheritance]
//[/user-inheritance]
{

public CVDelay( long moduleID, VoltageObjects voltageObjects )
{
   super( moduleID, voltageObjects, "Pitch Converter", ModuleType.ModuleType_Utility, 1.0 );

   InitializeControls();


   canBeBypassed = false;
   SetSkin( "bedde434836240269701184779c02457" );
}

void InitializeControls()
{

   textLabel1 = new VoltageLabel( "textLabel1", "textLabel1", this, "Dome Music Technologies" );
   AddComponent( textLabel1 );
   textLabel1.SetWantsMouseNotifications( false );
   textLabel1.SetPosition( 2, 341 );
   textLabel1.SetSize( 67, 19 );
   textLabel1.SetEditable( false, false );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel1.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel1.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel1.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel1.SetBorderSize( 1 );
   textLabel1.SetMultiLineEdit( true );
   textLabel1.SetIsNumberEditor( false );
   textLabel1.SetNumberEditorRange( 0, 100 );
   textLabel1.SetNumberEditorInterval( 1 );
   textLabel1.SetNumberEditorUsesMouseWheel( false );
   textLabel1.SetHasCustomTextHoverColor( false );
   textLabel1.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel1.SetFont( "Verdana", 7, false, false );

   textLabel2 = new VoltageLabel( "textLabel2", "textLabel2", this, "Pitch Converter" );
   AddComponent( textLabel2 );
   textLabel2.SetWantsMouseNotifications( false );
   textLabel2.SetPosition( 0, 0 );
   textLabel2.SetSize( 72, 32 );
   textLabel2.SetEditable( false, false );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel2.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel2.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel2.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel2.SetBorderSize( 1 );
   textLabel2.SetMultiLineEdit( true );
   textLabel2.SetIsNumberEditor( false );
   textLabel2.SetNumberEditorRange( 0, 100 );
   textLabel2.SetNumberEditorInterval( 1 );
   textLabel2.SetNumberEditorUsesMouseWheel( false );
   textLabel2.SetHasCustomTextHoverColor( false );
   textLabel2.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel2.SetFont( "Verdana", 14, false, false );

   inputVoltOct = new VoltageAudioJack( "1V / Oct Input", "1V / Oct Input", this, JackType.JackType_AudioInput );
   AddComponent( inputVoltOct );
   inputVoltOct.SetWantsMouseNotifications( false );
   inputVoltOct.SetPosition( 24, 51 );
   inputVoltOct.SetSize( 25, 25 );
   inputVoltOct.SetSkin( "Jack Round Yellow Ring" );

   textLabel3 = new VoltageLabel( "textLabel3", "textLabel3", this, "1V/Oct" );
   AddComponent( textLabel3 );
   textLabel3.SetWantsMouseNotifications( false );
   textLabel3.SetPosition( 7, 33 );
   textLabel3.SetSize( 56, 21 );
   textLabel3.SetEditable( false, false );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel3.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel3.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel3.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel3.SetBorderSize( 1 );
   textLabel3.SetMultiLineEdit( false );
   textLabel3.SetIsNumberEditor( false );
   textLabel3.SetNumberEditorRange( 0, 100 );
   textLabel3.SetNumberEditorInterval( 1 );
   textLabel3.SetNumberEditorUsesMouseWheel( false );
   textLabel3.SetHasCustomTextHoverColor( false );
   textLabel3.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel3.SetFont( "Verdana", 12, false, false );

   octaveSwitch = new VoltageSwitch( "Octave Select", "Octave Select", this, 1 );
   AddComponent( octaveSwitch );
   octaveSwitch.SetWantsMouseNotifications( false );
   octaveSwitch.SetPosition( 18, 84 );
   octaveSwitch.SetSize( 15, 51 );
   octaveSwitch.SetSkin( "4-State Slide Vertical" );

   textLabel4 = new VoltageLabel( "textLabel4", "textLabel4", this, "32'" );
   AddComponent( textLabel4 );
   textLabel4.SetWantsMouseNotifications( false );
   textLabel4.SetPosition( 35, 120 );
   textLabel4.SetSize( 20, 16 );
   textLabel4.SetEditable( false, false );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel4.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel4.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel4.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel4.SetBorderSize( 1 );
   textLabel4.SetMultiLineEdit( false );
   textLabel4.SetIsNumberEditor( false );
   textLabel4.SetNumberEditorRange( 0, 100 );
   textLabel4.SetNumberEditorInterval( 1 );
   textLabel4.SetNumberEditorUsesMouseWheel( false );
   textLabel4.SetHasCustomTextHoverColor( false );
   textLabel4.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel4.SetFont( "Verdana", 10, false, false );

   textLabel5 = new VoltageLabel( "textLabel5", "textLabel5", this, "16'" );
   AddComponent( textLabel5 );
   textLabel5.SetWantsMouseNotifications( false );
   textLabel5.SetPosition( 35, 108 );
   textLabel5.SetSize( 20, 15 );
   textLabel5.SetEditable( false, false );
   textLabel5.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel5.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel5.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel5.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel5.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel5.SetBorderSize( 1 );
   textLabel5.SetMultiLineEdit( false );
   textLabel5.SetIsNumberEditor( false );
   textLabel5.SetNumberEditorRange( 0, 100 );
   textLabel5.SetNumberEditorInterval( 1 );
   textLabel5.SetNumberEditorUsesMouseWheel( false );
   textLabel5.SetHasCustomTextHoverColor( false );
   textLabel5.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel5.SetFont( "Verdana", 10, false, false );

   textLabel6 = new VoltageLabel( "textLabel6", "textLabel6", this, "8'" );
   AddComponent( textLabel6 );
   textLabel6.SetWantsMouseNotifications( false );
   textLabel6.SetPosition( 40, 96 );
   textLabel6.SetSize( 15, 15 );
   textLabel6.SetEditable( false, false );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel6.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel6.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel6.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel6.SetBorderSize( 1 );
   textLabel6.SetMultiLineEdit( false );
   textLabel6.SetIsNumberEditor( false );
   textLabel6.SetNumberEditorRange( 0, 100 );
   textLabel6.SetNumberEditorInterval( 1 );
   textLabel6.SetNumberEditorUsesMouseWheel( false );
   textLabel6.SetHasCustomTextHoverColor( false );
   textLabel6.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel6.SetFont( "Verdana", 10, false, false );

   textLabel7 = new VoltageLabel( "textLabel7", "textLabel7", this, "4'" );
   AddComponent( textLabel7 );
   textLabel7.SetWantsMouseNotifications( false );
   textLabel7.SetPosition( 40, 84 );
   textLabel7.SetSize( 15, 15 );
   textLabel7.SetEditable( false, false );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel7.SetColor( new Color( 255, 255, 255, 255 ) );
   textLabel7.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel7.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel7.SetBorderSize( 1 );
   textLabel7.SetMultiLineEdit( false );
   textLabel7.SetIsNumberEditor( false );
   textLabel7.SetNumberEditorRange( 0, 100 );
   textLabel7.SetNumberEditorInterval( 1 );
   textLabel7.SetNumberEditorUsesMouseWheel( false );
   textLabel7.SetHasCustomTextHoverColor( false );
   textLabel7.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel7.SetFont( "Verdana", 10, false, false );

   semitoneKnob = new VoltageKnob( "Semitone Tune", "Semitone Tune", this, -12.0, 12.0, 0 );
   AddComponent( semitoneKnob );
   semitoneKnob.SetWantsMouseNotifications( false );
   semitoneKnob.SetPosition( 6, 158 );
   semitoneKnob.SetSize( 27, 27 );
   semitoneKnob.SetSkin( "Plastic White" );
   semitoneKnob.SetRange( -12.0, 12.0, 0, false, 25 );
   semitoneKnob.SetKnobParams( 215, 145 );
   semitoneKnob.DisplayValueInPercent( false );
   semitoneKnob.SetKnobAdjustsRing( true );

   fineTuneKnob = new VoltageKnob( "Fine Tune", "Fine Tune", this, -1.0, 1.0, 0 );
   AddComponent( fineTuneKnob );
   fineTuneKnob.SetWantsMouseNotifications( false );
   fineTuneKnob.SetPosition( 40, 158 );
   fineTuneKnob.SetSize( 27, 27 );
   fineTuneKnob.SetSkin( "Plastic White" );
   fineTuneKnob.SetRange( -1.0, 1.0, 0, false, 0 );
   fineTuneKnob.SetKnobParams( 215, 145 );
   fineTuneKnob.DisplayValueInPercent( false );
   fineTuneKnob.SetKnobAdjustsRing( true );

   textLabel9 = new VoltageLabel( "textLabel9", "textLabel9", this, "Semi" );
   AddComponent( textLabel9 );
   textLabel9.SetWantsMouseNotifications( false );
   textLabel9.SetPosition( 6, 142 );
   textLabel9.SetSize( 25, 16 );
   textLabel9.SetEditable( false, false );
   textLabel9.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel9.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel9.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel9.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel9.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel9.SetBorderSize( 1 );
   textLabel9.SetMultiLineEdit( false );
   textLabel9.SetIsNumberEditor( false );
   textLabel9.SetNumberEditorRange( 0, 100 );
   textLabel9.SetNumberEditorInterval( 1 );
   textLabel9.SetNumberEditorUsesMouseWheel( false );
   textLabel9.SetHasCustomTextHoverColor( false );
   textLabel9.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel9.SetFont( "Verdana", 10, false, false );

   textLabel14 = new VoltageLabel( "textLabel14", "textLabel14", this, "Comp" );
   AddComponent( textLabel14 );
   textLabel14.SetWantsMouseNotifications( false );
   textLabel14.SetPosition( 36, 287 );
   textLabel14.SetSize( 34, 15 );
   textLabel14.SetEditable( false, false );
   textLabel14.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel14.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel14.SetColor( new Color( 255, 0, 0, 255 ) );
   textLabel14.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel14.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel14.SetBorderSize( 1 );
   textLabel14.SetMultiLineEdit( false );
   textLabel14.SetIsNumberEditor( false );
   textLabel14.SetNumberEditorRange( 0, 100 );
   textLabel14.SetNumberEditorInterval( 1 );
   textLabel14.SetNumberEditorUsesMouseWheel( false );
   textLabel14.SetHasCustomTextHoverColor( false );
   textLabel14.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel14.SetFont( "Verdana", 12, false, false );

   textLabel10 = new VoltageLabel( "textLabel10", "textLabel10", this, "Fine" );
   AddComponent( textLabel10 );
   textLabel10.SetWantsMouseNotifications( false );
   textLabel10.SetPosition( 39, 142 );
   textLabel10.SetSize( 29, 16 );
   textLabel10.SetEditable( false, false );
   textLabel10.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel10.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel10.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel10.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel10.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel10.SetBorderSize( 1 );
   textLabel10.SetMultiLineEdit( false );
   textLabel10.SetIsNumberEditor( false );
   textLabel10.SetNumberEditorRange( 0, 100 );
   textLabel10.SetNumberEditorInterval( 1 );
   textLabel10.SetNumberEditorUsesMouseWheel( false );
   textLabel10.SetHasCustomTextHoverColor( false );
   textLabel10.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel10.SetFont( "Verdana", 10, false, false );

   CV1Knob = new VoltageKnob( "CV 1 Attenuator", "CV 1 Attenuator", this, -1.0, 1.0, 0.0 );
   AddComponent( CV1Knob );
   CV1Knob.SetWantsMouseNotifications( false );
   CV1Knob.SetPosition( 38, 205 );
   CV1Knob.SetSize( 32, 32 );
   CV1Knob.SetSkin( "Plastic Mint" );
   CV1Knob.SetRingSkin( "Crescent Mint/Green" );
   CV1Knob.SetRange( -1.0, 1.0, 0.0, false, 0 );
   CV1Knob.SetKnobParams( 215, 145 );
   CV1Knob.DisplayValueInPercent( false );
   CV1Knob.SetKnobAdjustsRing( false );

   inputCV1 = new VoltageAudioJack( "CV 1 Input", "CV 1 Input", this, JackType.JackType_AudioInput );
   AddComponent( inputCV1 );
   inputCV1.SetWantsMouseNotifications( false );
   inputCV1.SetPosition( 7, 207 );
   inputCV1.SetSize( 25, 25 );
   inputCV1.SetSkin( "Jack Round Mint Ring" );

   textLabel11 = new VoltageLabel( "textLabel11", "textLabel11", this, "CV Oct" );
   AddComponent( textLabel11 );
   textLabel11.SetWantsMouseNotifications( false );
   textLabel11.SetPosition( 1, 189 );
   textLabel11.SetSize( 71, 16 );
   textLabel11.SetEditable( false, false );
   textLabel11.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel11.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel11.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel11.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel11.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel11.SetBorderSize( 1 );
   textLabel11.SetMultiLineEdit( false );
   textLabel11.SetIsNumberEditor( false );
   textLabel11.SetNumberEditorRange( 0, 100 );
   textLabel11.SetNumberEditorInterval( 1 );
   textLabel11.SetNumberEditorUsesMouseWheel( false );
   textLabel11.SetHasCustomTextHoverColor( false );
   textLabel11.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel11.SetFont( "Verdana", 12, false, false );

   textLabel12 = new VoltageLabel( "textLabel12", "textLabel12", this, "CV Semi" );
   AddComponent( textLabel12 );
   textLabel12.SetWantsMouseNotifications( false );
   textLabel12.SetPosition( 0, 234 );
   textLabel12.SetSize( 72, 18 );
   textLabel12.SetEditable( false, false );
   textLabel12.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel12.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel12.SetColor( new Color( 0, 0, 0, 255 ) );
   textLabel12.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel12.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel12.SetBorderSize( 1 );
   textLabel12.SetMultiLineEdit( false );
   textLabel12.SetIsNumberEditor( false );
   textLabel12.SetNumberEditorRange( 0, 100 );
   textLabel12.SetNumberEditorInterval( 1 );
   textLabel12.SetNumberEditorUsesMouseWheel( false );
   textLabel12.SetHasCustomTextHoverColor( false );
   textLabel12.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel12.SetFont( "Verdana", 12, false, false );

   CV2Knob = new VoltageKnob( "CV 2 Attenuator", "CV 2 Attenuator", this, -1.0, 1.0, 0.0 );
   AddComponent( CV2Knob );
   CV2Knob.SetWantsMouseNotifications( false );
   CV2Knob.SetPosition( 38, 251 );
   CV2Knob.SetSize( 32, 32 );
   CV2Knob.SetSkin( "Plastic Mint" );
   CV2Knob.SetRingSkin( "Crescent Mint/Green" );
   CV2Knob.SetRange( -1.0, 1.0, 0.0, false, 0 );
   CV2Knob.SetKnobParams( 215, 145 );
   CV2Knob.DisplayValueInPercent( false );
   CV2Knob.SetKnobAdjustsRing( false );

   inputCV2 = new VoltageAudioJack( "CV 2 Input", "CV 2 Input", this, JackType.JackType_AudioInput );
   AddComponent( inputCV2 );
   inputCV2.SetWantsMouseNotifications( false );
   inputCV2.SetPosition( 7, 253 );
   inputCV2.SetSize( 25, 25 );
   inputCV2.SetSkin( "Jack Round Mint Ring" );

   compKnob = new VoltageKnob( "Compensation", "Compensation", this, 0, 10, 0 );
   AddComponent( compKnob );
   compKnob.SetWantsMouseNotifications( false );
   compKnob.SetPosition( 42, 305 );
   compKnob.SetSize( 22, 22 );
   compKnob.SetSkin( "Plastic Maroon" );
   compKnob.SetRange( 0, 10, 0, false, 11 );
   compKnob.SetKnobParams( 215, 145 );
   compKnob.DisplayValueInPercent( false );
   compKnob.SetKnobAdjustsRing( true );

   outputZeit = new VoltageAudioJack( "Zeit Output", "Zeit Output", this, JackType.JackType_AudioOutput );
   AddComponent( outputZeit );
   outputZeit.SetWantsMouseNotifications( false );
   outputZeit.SetPosition( 7, 303 );
   outputZeit.SetSize( 25, 25 );
   outputZeit.SetSkin( "Jack Round 25px" );
}



//-------------------------------------------------------------------------------
//  public void Initialize()

//  Initialize will get called shortly after your module's constructor runs. You can use it to
//  do any initialization that the auto-generated code doesn't handle.
//-------------------------------------------------------------------------------
@Override
public void Initialize()
{
   //[user-Initialize]   Add your own initialization code here

   previousSummedVoltage = 1.0;
   previousOutputVoltage = C_16_FEET_PERIOD;

   CheckConnections();
   ReadOctaveSwitch();
   
   smoothSemitone.SetValue (semitoneKnob.GetValue());
   smoothFine.SetValue (fineTuneKnob.GetValue());
   smoothCV1.SetValue (CV1Knob.GetValue());
   smoothCV2.SetValue (CV2Knob.GetValue());   

   //[/user-Initialize]
}


//-------------------------------------------------------------------------------
//  public void Destroy()

//  Destroy will get called just before your module gets deleted. You can use it to perform any
//  cleanup that's not handled automatically by Java.
//-------------------------------------------------------------------------------
@Override
public void Destroy()
{
   super.Destroy();
   //[user-Destroy]   Add your own module-getting-deleted code here



   //[/user-Destroy]
}


//-------------------------------------------------------------------------------
//  public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )

//  Notify will get called when various events occur - control values changing, timers firing, etc.
//-------------------------------------------------------------------------------
@Override
public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )
{
   //[user-Notify]   Add your own notification handling code between this line and the notify-close comment
   switch( notification )
   {
      case Knob_Changed:   // doubleValue is the new VoltageKnob value
      {
         if (component == semitoneKnob)
         {
            smoothSemitone.SetValue (semitoneKnob.GetValue());
         }
         else if (component == fineTuneKnob)
         {
            smoothFine.SetValue (fineTuneKnob.GetValue());
         }
         else if (component == CV1Knob)
         {
            smoothCV1.SetValue (CV1Knob.GetValue());
         }
         else if (component == CV2Knob)
         {
            smoothCV2.SetValue (CV2Knob.GetValue());
         }
      }
      break;
   
      case Slider_Changed:   // doubleValue is the new slider value
      {
      }
      break;
   
      case Button_Changed:   // doubleValue is the new button/toggle button value
      {
      }
      break;
   
      case Switch_Changed:   // doubleValue is the new switch value
      {
         ReadOctaveSwitch();
      }
      break;
   
      case Jack_Connected:   // longValue is the new cable ID
      {
         CheckConnections();
      }
      break;
   
      case Jack_Disconnected:   // All cables have been disconnected from this jack
      {
         CheckConnections();
      }
      break;
   
      case GUI_Update_Timer:   // Called every 50ms (by default) if turned on
      {
      }
      break;
   
      case Object_MouseMove:   // called when mouse is over an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_MouseLeave:  // called when mouse leaves an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonDown:   // called when user left-clicks on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonUp:   // called when user releases left mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonDown:   // called when user releases right mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonUp:   // called when user right-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      case Object_LeftButtonDoubleClick: // called when user left-button double-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      // Less common notifications:
   
      case Named_Timer:   // object contains a String with the name of the timer that has fired
      {
      }
      break;
   
      case Canvas_Painting:   // About to paint canvas.  object is a java.awt.Rectangle with painting boundaries
      {
      }
      break;
   
      case Canvas_Painted:   // Canvas painting is complete
      {
      }
      break;
   
      case Control_DragStart:    // A user has started dragging on a control that has been marked as draggable
      {
      }
      break;
   
      case Control_DragOn:       // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragOff:      // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragEnd:      // A user has ended their drag on a control that has been marked as draggable
      {
      }
      break;
   
      case Label_Changed:        // The text of an editable text control has changed
      {
      }
      break;
   
      case SoundPlayback_Start:   // A sound has begun playback
      {
      }
      break;
   
      case SoundPlayback_End:     // A sound has ended playback
      {
      }
      break;
   
      case Scrollbar_Position:    // longValue is the new scrollbar position
      {
      }
      break;
   
      case PolyVoices_Changed:    // longValue is the new number of poly voices
      {
      }
      break;
   
      case File_Dropped:     // 'object' is a String containing the file path
      {
      }
      break;
   
      case Preset_Loading_Start:   // called when preset loading begins
      {
      }
      break;
   
      case Preset_Loading_Finish:  // called when preset loading finishes
      {
      }
      break;
   
      case Variation_Loading_Start:    // sent when a variation is about to load
      {
      }
      break;
   
      case Variation_Loading_Finish:   // sent when a variation has just finished loading
      {
      }
      break;
   
      case Tempo_Changed:     // doubleValue is the new tempo
      {
      }
      break;
   
      case Randomized:     // called when the module's controls get randomized
      {
      }
      break;
   
      case VariationListChanged:   // sent when a variation gets added, deleted, or renamed, or the variations list gets reordered
      {
      }
      break;
   
      case Key_Press:     // sent when module has keyboard focus and a key is pressed; object is a VoltageKeyPressInfo object
      {
      }
      break;
   
      case Reset:    // sent when the module has been reset to default settings
      {
      }
      break;
   
      case Keyboard_NoteOn:   // sent when a note has been pressed on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Keyboard_NoteOff:   // sent when a note has been released on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Curve_Changed:   // sent when user has edited a curve's value. 'object' will be a VoltageCurve.CurveChangeNotification object.
      {
      }
      break;
   }



   return false;
   //[/user-Notify]
}


//-------------------------------------------------------------------------------
//  public void ProcessSample()

//  ProcessSample is called once per sample. Usually it's where you read
//  from input jacks, process audio, and write it to your output jacks.
//  Since ProcesssSample gets called 48,000 times per second, offload CPU-intensive operations
//  to other threads when possible and avoid calling native functions.
//-------------------------------------------------------------------------------
@Override
public void ProcessSample()
{
   //[user-ProcessSample]   Add your own process-sampling code here

   float    tempFloat;
   double   tempDouble;
   double   voltPerOctaveIn;
   double   cv1input;
   double   cv2input;
   double   smoothedSemi;
   double   smoothedFine;
   double   smoothedCV1;
   double   smoothedCV2;

   // Do all smoothing every sample period
   smoothedSemi = smoothSemitone.GetSmoothValue();
   smoothedFine = smoothFine.GetSmoothValue();
   smoothedCV1 = smoothCV1.GetSmoothValue();
   smoothedCV2 = smoothCV2.GetSmoothValue();
   
   // Only perform intensive processing if output socket connected
   if (outputConnected)
   {
      // Read 1V/Oct input
      currentSummedVoltage = inputVoltOct.GetValue();
      
      // Add Octave Selector switch voltage
      currentSummedVoltage += octaveVoltage;
      
      // Adjust for tuning knob settings
      currentSummedVoltage += smoothedSemi * VOLTS_PER_SEMITONE;
      currentSummedVoltage += smoothedFine * VOLTS_PER_SEMITONE;

      // Read CV inputs if they are connected
      if (CV1Connected)
      {
         currentSummedVoltage += smoothedCV1 * inputCV1.GetValue() * OCTAVE_MULTIPLIER;
      }      
      
      if (CV2Connected)
      {
         currentSummedVoltage += smoothedCV2 * inputCV2.GetValue() * SEMITONE_MULTIPLIER;
      }
      
      // Only perform exponentiation and division if necessary
      if (currentSummedVoltage != previousSummedVoltage)
      {
         outputVoltage = C_32_FEET_PERIOD / pow (2.0, currentSummedVoltage);
         previousSummedVoltage = currentSummedVoltage;
         previousOutputVoltage = outputVoltage;
      }
      else
      {
         outputVoltage = previousOutputVoltage;
      }
      
      // Finally, subtract compensation value 
      outputVoltage -= compKnob.GetValue() * SAMPLE_DURATION;
      
      outputZeit.SetValue(outputVoltage);
      
   }

   //[/user-ProcessSample]
}


//-------------------------------------------------------------------------------
//  public String GetTooltipText( VoltageComponent component )

//  Gets called when a tooltip is about to display for a control. Override it if
//  you want to change what the tooltip displays - if you want a knob to work in logarithmic fashion,
//  for instance, you can translate the knob's current value to a log-based string and display it here.
//-------------------------------------------------------------------------------
@Override
public String GetTooltipText( VoltageComponent component )
{
   //[user-GetTooltipText]   Add your own code here



   return super.GetTooltipText( component );
   //[/user-GetTooltipText]
}


//-------------------------------------------------------------------------------
//  public void EditComponentValue( VoltageComponent component, double newValue, String newText )

//  Gets called after a user clicks on a tooltip and types in a new value for a control. Override this if
//  you've changed the default tooltip display (translating a linear value to logarithmic, for instance)
//  in GetTooltipText().
//-------------------------------------------------------------------------------
@Override
public void EditComponentValue( VoltageComponent component, double newValue, String newText )
{
   //[user-EditComponentValue]   Add your own code here



   //[/user-EditComponentValue]
   super.EditComponentValue( component, newValue, newText );
}


//-------------------------------------------------------------------------------
//  public void OnUndoRedo( String undoType, double newValue, Object optionalObject )

//  If you've created custom undo events via calls to CreateUndoEvent, you'll need to
//  process them in this function when they get triggered by undo/redo actions.
//-------------------------------------------------------------------------------
@Override
public void OnUndoRedo( String undoType, double newValue, Object optionalObject )
{
   //[user-OnUndoRedo]   Add your own code here



   //[/user-OnUndoRedo]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformation()

//  Gets called when the module's state gets saved, typically when the user saves a preset with
//  this module in it. Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformation()
{
   //[user-GetStateInformation]   Add your own code here



   return null;
   //[/user-GetStateInformation]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformation(byte[] stateInfo)

//  Gets called when this module's state is getting restored, typically when a user opens a preset with
//  this module in it. The stateInfo parameter will contain whatever custom data you stored in GetStateInformation().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformation(byte[] stateInfo)
{
   //[user-SetStateInformation]   Add your own code here



   //[/user-SetStateInformation]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformationForVariations()

//  Gets called when a user saves a variation with this module in it.
//  Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformationForVariations()
{
   //[user-GetStateInformationForVariations]   Add your own code here



   return GetStateInformation();
   //[/user-GetStateInformationForVariations]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformationForVariations(byte[] stateInfo)

//  Gets called when a user loads a variation with this module in it.
//  The stateInfo parameter will contain whatever custom data you stored in GetStateInformationForVariations().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformationForVariations(byte[] stateInfo)
{
   //[user-SetStateInformationForVariations]   Add your own code here
   SetStateInformation(stateInfo);



   //[/user-SetStateInformationForVariations]
}


// Auto-generated variables
private VoltageAudioJack outputZeit;
private VoltageKnob compKnob;
private VoltageAudioJack inputCV2;
private VoltageKnob CV2Knob;
private VoltageLabel textLabel12;
private VoltageLabel textLabel11;
private VoltageAudioJack inputCV1;
private VoltageKnob CV1Knob;
private VoltageLabel textLabel10;
private VoltageLabel textLabel14;
private VoltageLabel textLabel9;
private VoltageKnob fineTuneKnob;
private VoltageKnob semitoneKnob;
private VoltageLabel textLabel7;
private VoltageLabel textLabel6;
private VoltageLabel textLabel5;
private VoltageLabel textLabel4;
private VoltageSwitch octaveSwitch;
private VoltageLabel textLabel3;
private VoltageAudioJack inputVoltOct;
private VoltageLabel textLabel2;
private VoltageLabel textLabel1;


//[user-code-and-variables]    Add your own variables and functions here


// Constants

private final double SAMPLE_DURATION = 1.0 / Values.SampleRate;
private final double VOLTS_PER_OCTAVE = 1.0;
private final double VOLTS_PER_SEMITONE = VOLTS_PER_OCTAVE / 12.0;
private final double C_32_FEET_PERIOD = 0.030577533;
private final double C_16_FEET_PERIOD = C_32_FEET_PERIOD / 2.0;
private final double OCTAVE_MULTIPLIER = 1.0 / 5.0;
private final double SEMITONE_MULTIPLIER = OCTAVE_MULTIPLIER / 12.0;


// Variables

private boolean voltsOctConnected;
private boolean CV1Connected;
private boolean CV2Connected;
private boolean outputConnected;
private double  octaveVoltage;

private double currentSummedVoltage;
private double previousSummedVoltage;
private double outputVoltage;
private double previousOutputVoltage;

// Objects

private SmoothValue smoothSemitone = new SmoothValue();
private SmoothValue smoothFine = new SmoothValue();
private SmoothValue smoothCV1 = new SmoothValue();
private SmoothValue smoothCV2 = new SmoothValue();

// Functions

private void ReadOctaveSwitch()
{
   octaveVoltage = octaveSwitch.GetValue();
}

private void CheckConnections()
{
   voltsOctConnected = inputVoltOct.IsConnected();
   CV1Connected = inputCV1.IsConnected();
   CV2Connected = inputCV2.IsConnected();
   outputConnected = outputZeit.IsConnected();
}


//[/user-code-and-variables]
}

 